/**	This file contains the interpolation function in eq. 2.13 in GKM "A more powerfull subvector Anderson Rubin test in linear IV regression"
**/

#include <oxprob.oxh>

interpolate(const x, const x_up, const x_lo, const y_up, const y_lo)
/**	This function returns linear interpolation of [y_lo,y_up] for x \in [x_lo,x_up].
	if x_up = .Inf, use nonlinear interpolation using exponential distribution function
**/
{
	if(x_up < .Inf)
		return y_lo + (x - x_lo)*(y_up - y_lo)/(x_up - x_lo);			// linear interpolation
//	else
	decl xt = probexp(x - x_lo,1);				// transform x-x_lo into [0,1] using exponential df
	decl dcv = y_lo + xt*(y_up - y_lo);			// nonlinear interpolation (linear in transformed space)
	return dcv;				
}														 		
